=== debian/changelog ===
rocalution (5.7.1-3) unstable; urgency=medium

  * d/rules: fix path to build tests on i386
  * d/gbp.conf: ensure use of pristine-tar

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 03 Jul 2024 15:53:55 -0600

rocalution (5.7.1-2) unstable; urgency=medium

  * Migrate to unstable.

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 20 Feb 2024 10:14:40 -0700

rocalution (5.7.1-1) experimental; urgency=medium

  * Initial release. (Closes: #1023168)

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 12 Feb 2024 13:59:17 -0700
