=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocalution-$1.tar.gz%" \
    https://github.com/rocm/rocalution/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
